function ENT=ik_ent(n,t,QOUT)
          % t:  No. of computation steps
          % n:  No. of qbits
nm=2^n;   % nm: No. of states

% Initialization of Entanglement Evolutiom Matrix

for i=1:n;
    for j=1:t+1;
        ENT(i,j)=0;
    end
end

for i=1:t+1;
    PLENT(i)=0.0;
end
%--------------------------------------------------------------------
% This function generates and plots the Entanglement Evolution Matrix
%
% The inputs are the number of qbits (n) and the Probability 
% Amplitude matrix (QOUT).
% The function "ik_dec2binarray" is used to convert the decimal
% state representation to a binary array.
%                                              5/11/2003
%--------------------------------------------------------------------

for step=1:t+1;  % Loop Computation steps
    S=QOUT(:,step);  % QC state at computation step step
    DM=S*S';  % Density Matrix

    for qbit=1:n; %Loop qbits
        
        % Initialization of Reduced Density Matrix elements for this qbit
        RDM(1,1)=0;
        RDM(1,2)=0;
        RDM(2,1)=0;
        RDM(2,2)=0;
        
        for i=1:nm;     % Loop Density
            for j=1:nm; % Matrix elements
                % Orthogonality check
                        if (DM(i,j)~=0) % Non-zero elements of DM    
                           ST=ik_dec2binarray(n,i-1);
                           TS=ik_dec2binarray(n,j-1);
                           RST=ST+TS;
                           orto=0; % Orthogonality
                           for k=1:n;
                               if ((RST(k)==1)&(k~=qbit))
                               orto=1; % ST(k) and TS(k) in the Hilbert subspace are orthogonal                       
                               end % end if RST
                           end % for k 
                           
                               if (orto==0)% Then DM(i,j) not zero and ST(k) and TS(k) are not orthogonal
                                  % Four cases: |0><0|, |1><0|, |0><1| and |1><1|
                                     if ((ST(qbit)==0)&(TS(qbit)==0))     % Case |0><0|
                                         RDM(1,1)=RDM(1,1)+DM(i,j);
                                     elseif ((ST(qbit)==0)&(TS(qbit)==1)) % Case |0><1|
                                         RDM(1,2)=RDM(1,2)+DM(i,j);
                                     elseif ((ST(qbit)==1)&(TS(qbit)==0)) % Case |1><0|
                                         RDM(2,1)=RDM(2,1)+DM(i,j);
                                     elseif ((ST(qbit)==1)&(TS(qbit)==1)) % Case |1><1|
                                         RDM(2,2)=RDM(2,2)+DM(i,j);
                                     end                               
                               end % if ORTH
                    
                        end % if DM              
                
            end %for j
        end % for i

% Entanglement Calculation for the qbit "qbit" at computation step "step"
% The entanglement units are "ebits"

 [EVE, EVA]=eig(RDM);  % EVE=Eigenvectors of A in columns, 
                      % EVA=Eigenvalues of A as diagonal elements.           

% Entrp is the Entropy of the qbit with density matrix A

Entrp=0.0; % Initialisation

for k=1:2;
      if(EVA(k,k)==0);
          Enrp=0;
      else
      Enrp=-EVA(k,k)*log2(EVA(k,k));
      end
    Entrp=Entrp+Enrp;
end

ENT(qbit,step)=Entrp;

    end  % for qbit

end  % for step

% ----- PLOT --------

for p=1:t+1;
      for q=1:n;
      PLENT(p)=PLENT(p)+ENT(q,p);
      end
end

% - - - - 1-D Matrices for axis ticks - - -

%     X Axis
    stepx=ceil (t/10);
    x_tik=1:stepx:t+1;
    
%     Y Axis
if (min(PLENT)>=0)
    ydown=0;
else
    ydown=floor(min(PLENT));
end
yup=ceil(max(PLENT));
stepy=1;% ceil(n/2);
y_tik=ydown:stepy:yup+1;

% - - - - End Matrices for axis ticks - - - 
hold off
figure('NumberTitle','off','Name','D.U.Th.  Quantum Computer Simulator                     Dr. Ioannis Karafyllidis');
plot(PLENT,'k')
     %axis image
     xlabel('Computation Steps')
     ylabel('Entanglement (ebits)')
     set(gca,'ytick',y_tik,'xtick',x_tik); 
     YLim([ydown yup+1]);
hold off     
figure('NumberTitle','off','Name','D.U.Th.  Quantum Computer Simulator                     Dr. Ioannis Karafyllidis');
bar(PLENT,'k') 
     %bar(PLENT,0.6,'k')
     xlabel('Computation Steps')
     ylabel('Entanglement (ebits)')
     set(gca,'ytick',y_tik,'xtick',x_tik); 
     YLim([ydown yup+1]);
     XLim([1 t+2]);
    
